var createError = require("http-errors");
var express = require("express");
var path = require("path");
var session = require("express-session");
var cookieParser = require("cookie-parser");
var logger = require("morgan");
var passport = require("passport");
var hbs = require("hbs");
const flash = require("express-flash");

var indexRouter = require("./routes/index");
var usersRouter = require("./routes/users");
var loginRouter = require("./routes/login");
var adminRouter = require("./routes/admin");
var dashboardRouter = require("./routes/dashboard");
var profileRouter = require("./routes/profile");
var editprofileRouter = require("./routes/editprofile");
var AddTechnicianRouter = require("./routes/AddTechnician");

var app = express();

var Admin = require("./models/Admin");
// Admin.sync({ force: true });
// Admin.sync({ alter: true });

var AddTechnician = require("./models/AddTechnician");
// AddTechnician.sync({ force: true });
// AddTechnician.sync({ alter: true });

var Form1 = require("./models/Form1");
// Form1.sync({ force: true });
// Form1.sync({ alter: true });

var Form2 = require("./models/form2");
// Form2.sync({ force: true });
// Form2.sync({ alter: true });

var Form3 = require("./models/form3");
// Form3.sync({ force: true });
// Form3.sync({ alter: true });

// var Event = require("./models/Event");
//  Event.sync({alter:true})

// Admin.sync({force:true})
// var Notification = require("./models/Notification");
// Notification.sync({force:true})
// view engine setup

app.set("views", path.join(__dirname, "views"));
app.set("view engine", "hbs");
const partialsPath = path.join(__dirname, "views/partials");
hbs.registerPartials(partialsPath);
app.use(logger("dev"));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, "public")));
app.use("/upload_image", express.static("upload_image"));

app.get("/reset-password/:id/:token", (req, res) => {
	res.render("reset");
});

app.use(
	session({
		secret: "secret",
		resave: false,
		saveUninitialized: true,
	})
);
require("./middleware/passport")(passport);

app.use(passport.initialize());
app.use(passport.session());
app.use(flash());
app.use((req, res, next) => {
	res.locals.success_msg = req.flash("success_msg");
	res.locals.error_msg = req.flash("error_msg");
	res.locals.error = req.flash("error");
	console.log(req.user);
	res.locals.user = req.user;

	next();
});

app.use("/", indexRouter);
app.use("/users", usersRouter);
app.use("/login", loginRouter);
app.use("/admin", adminRouter);
app.use("/dashboard", dashboardRouter);
app.use("/profile", profileRouter);
app.use("/editprofile", editprofileRouter);

app.use("/AddTechnician", AddTechnicianRouter);
// catch 404 and forward to error handler
app.use(function (req, res, next) {
	next(createError(404));
});

// error handler
app.use(function (err, req, res, next) {
	// set locals, only providing error in development
	res.locals.message = err.message;
	res.locals.error = req.app.get("env") === "development" ? err : {};

	// render the error page
	res.status(err.status || 500);
	res.render("error");
});

// app.get('/test', (req, res) => {
//   res.send('Hello, world!');
// });
// app.listen(3000);

module.exports = app;
