const jwt = require("jsonwebtoken");
const { JWT_SECRET } = require("../config/key");
// const = require('../config/key')
// const key = 'yoursecretkey';
// Update the userAuth middleware

const userAuth = async (req, res, next) => {
	const token = req.header("Authorization");

	// Check if token is provided
	if (!token)
		return res
			.status(401)
			.json({ status: 0, message: "Invalid Token or No token Provided" });

	try {
		const decoded = jwt.verify(token, JWT_SECRET);
		req.user = { id: decoded.id }; // Attach user data to req.user
		console.log(req.user, "user....................");
		next();
	} catch (ex) {
		return res.status(400).json({ status: 0, message: "Invalid Token" });
	}
};

module.exports = userAuth;
