const express = require("express");
const router = express.Router();
const multer = require("../middleware/multer");
const UserAuth = require("../middleware/UserAuth");
const AdminController = require("../Controller/AdminController");
const Admin = require("../models/Admin");
const nodemailer = require("nodemailer");

router.post("/register", multer.single("image"), AdminController.AdminRegister);

router.get("/test", async (req, res, next) => {
	try {
		// Log that the /test endpoint is accessed
		console.log("GET request to /test endpoint");

		// You can perform any logic or processing here if needed
		// For now, let's just send a simple message as a response
		res.status(200).json({ message: "Test API is working!" });
	} catch (error) {
		// Log any errors that occur
		console.error("Error in /test endpoint:", error);

		// Pass the error to the error handling middleware
		next(error);
	}
});

var transporter = nodemailer.createTransport({
	service: "gmail",
	port: 465,
	secure: true, // true for 465, false for other ports
	logger: true,
	debug: true,
	secureConnection: false,
	auth: {
		user: "tryoutscout@gmail.com", // generated ethereal user
		pass: "xapfekrrmvvghexe", // generated ethereal password
	},
	tls: {
		rejectUnAuthorized: true,
	},
});
// Middleware to parse JSON requests
// app.use(express.json());

// Route to send email

router.post("/send-email", async (req, res) => {
	try {
		const transporter = nodemailer.createTransport({
			host: "smtp.gmail.com",
			port: 465,
			secure: true,
			auth: {
				user: "sendmail3130786@gmail.com",
				pass: "vgfoyhfsramldwdp",
			},
		});

		const info = await transporter.sendMail({
			from: "sendmail3130786@gmail.com",
			to: "belimruhan6@gmail.com",
			subject: "Test Email",
			text: "Hello world ?",
		});

		res.json({ message: "Email sent successfully" });
	} catch (error) {
		console.error(error); // Log the error for debugging purposes

		// Send the error message in the response
		res
			.status(500)
			.json({ error: "Internal Server Error", message: error.message });
	}
});

router.get("/dashboard-count", UserAuth, AdminController.dashBoardCounts);

module.exports = router;
