var express = require("express");
var router = express.Router();
var Admin = require("../models/Admin");
var Technician = require("../models/AddTechnician");
var { isLoggedIn } = require("../middleware/auth");

router.get("/", isLoggedIn, async function (req, res, next) {
	try {
		const id = req.user.id;

		const admin = await Admin.findOne({
			where: {
				id: id,
			},
		});

		if (!admin) {
			return res.status(401).json({
				status: 0,
				message: "Un-Authorized Access Denied",
			});
		}

		const techCounts = await Technician.count();

		res.render("dashboard", { techCounts: techCounts });
	} catch (error) {
		console.log("Error :-", error);
	}
});

module.exports = router;
