const express =require('express')
var router = express.Router();
const bcrypt = require('bcryptjs')
const util = require('util');
const { Op } = require('sequelize');

// const query = util.promisify(conn.query).bind(conn);
router.get('/reset/:token', (req, res) => {
  const token = req.params.token;
  res.render('reset', { token: req.params.token });
});
const  User  = require('../models/User'); // Adjust the path based on your project structure
const { Sequelize } = require('sequelize');

router.post('/reset/:token', async (req, res) => {
  const { token, password } = req.body;

  try {
    // Find the user by reset_token
    const user = await User.findOne({
      where: {
        reset_token: token,
        // reset_expiry: { [Sequelize.Op.gte]: new Date() }, // Check if reset token is not expired
      },
    });

    if (!user) {
      return res.status(400).send('Invalid reset token');
    }

    // Hash the new password
    const hashedPassword = await bcrypt.hash(password, 10);

    // Update the user's password, reset_token, and reset_expiry
    await user.update({
      password: hashedPassword,
      reset_token: null,
    //   reset_expiry: null,
    });

    // Render the success page or send a JSON response
    res.json({ status: 'success', message: 'Password reset successfully' });
  } catch (error) {
    console.error(error);
    res.status(500).json({ message: 'Error resetting password' });
  }
});
module.exports=router