var express = require("express");
var router = express.Router();
const UserController = require("../Controller/UserController");
const Form1 = require("../models/Form1");
const upload_image = require("../middleware/multer");
const { where } = require("sequelize");
const userAuth = require("../middleware/UserAuth");

router.post("/Login", UserController.UserLogin);

router.post("/forgot", UserController.forgotPass);

router.post("/reset-password", UserController.resetPassword);

//<<<<<<<<<<<<<<<<<<<<<<<< FORM2 CRUD >>>>>>>>>>>>>>>>>
router.post(
	"/add-form-1",
	upload_image.single("signature"),
	userAuth,
	UserController.createForm1
);

//<<<<<<<<<<<<<<<<<<<<<<<< FORM2 CRUD >>>>>>>>>>>>>>>>>
router.post(
	"/add-form",
	upload_image.single("signature"),
	userAuth,
	UserController.createForm
);

router.post(
	"/update-form",
	userAuth,
	upload_image.single("signature"),
	UserController.updateForm
);

router.post("/form-detail", userAuth, UserController.formDetail);

router.post("/form-delete", userAuth, UserController.removeForm);

//<<<<<<<<<<<<<<<<<<<<<<<< FORM3 CRUD >>>>>>>>>>>>>>>>>
router.post(
	"/form-add-3",
	upload_image.single("signature"),
	userAuth,
	UserController.createForm3
);

router.post("/form-detail-3", UserController.formDetail3);

router.post("/delete-form-3", UserController.removeForm3);

module.exports = router;
